=== debian/changelog ===
faust (2.20.2~ds0-1) unstable; urgency=medium

  [ IOhannes m zmölnig (Debian/GNU) ]
  * New upstream version 2.20.2~ds0
    * Refresh patches
    * More spelling fixes
  * Explicitly recommend "python3"
  * Declare that building this package does not require "root" powers
  * Reordered homepage field
  * Remove files from d/copyright that are not longer in the package
  * Remove lintian-overrides for removed files
  * Added more lintian-overrides after checking with upstream
  * Update version-mangling in d/watch

  [ Ondřej Nový ]
  * Bump Standards-Version to 4.4.1

  [ Olivier Humbert ]
  * Update copyright (http -> https + remove 1 empty line)

 -- IOhannes m zmölnig (Debian/GNU) <umlaeute@debian.org>  Fri, 10 Jan 2020 11:17:45 +0100

faust (2.15.11~ds1-3) unstable; urgency=medium

  * Source-only upload to unstable.

 -- IOhannes m zmölnig (Debian/GNU) <umlaeute@debian.org>  Thu, 19 Sep 2019 15:12:15 +0200

faust (2.15.11~ds1-2) unstable; urgency=medium

  * Package 'libfaust2' containing the support libraries (Closes: #939704)
  * Add patch to fix minor spelling mistakes
  * Update lintian-overrides for sources
  * Update d/copyright
    * Regenerate d/copyright_hints
  * Bump dh compat to 12

 -- IOhannes m zmölnig (Debian/GNU) <umlaeute@debian.org>  Thu, 12 Sep 2019 14:37:35 +0200
