=== debian/watch ===
version=4
opts=dversionmangle=auto,oversionmangle=s/$/~ds0/ \
  https://github.com/grame-cncm/faust/releases .*/faust-(\d\S*)\.tar\.gz
